SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

!MonthOfYear class methodsFor: '*EjerciciosPoo-TusLibros' stamp: 'BarroumeresLaje 6/17/2012 19:40'!
current
	|now|
	now := DateAndTime current.
	^self new initializeOnMonthNumber: now monthIndex of: now year.
	
	

	
! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
book100MasDeUnSigloRojoYBlanco

	^'9789507543340'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
bookLTA

	^'9789876480390'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
bookSerDeRiver

	^'9789500737111'



! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/16/2012 23:47'!
fiftyARS

	^MonetaryAmount of: 50 in: MonetaryCurrency ARS.
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/24/2012 14:43'!
merchantProcessorInterfaceOffline

	^MerchantProcessorInterfaceStub respondingOnDebit: [ConnectionTimedOut signal: 'Merchant Processor fuera de linea'].
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/24/2012 14:39'!
merchantProcessorInterfaceREST

	^MerchantProcessorInterfaceREST new.
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/16/2012 23:47'!
oneHundredARS

	^MonetaryAmount of: 100 in: MonetaryCurrency ARS.
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 21:40'!
test01CartShouldBeEmptyWhenCreated

	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	self assert: aCart isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:51'!
test02CartIsNoLongerEmptyWhenAddingItems

	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.
	aCart add: self bookLTA  quantity: 1.
	
	self deny: aCart isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:50'!
test03AddToCartAddTheCorrectAmountOfBooksToTheCart

	|aCart aCatalogue q|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	q := aCart quantityOf: self bookLTA  .
	aCart add: self bookLTA  quantity:  10.
	self assert: (aCart quantityOf: self bookLTA ) = (10 + q).
	
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 23:43'!
test04CanNotAddNegativeQuantitiesOfItems

	|aCart aCatalogue q|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.
	
	q := aCart quantityOf: self bookLTA.
 	self should: [aCart add: self bookLTA  quantity: -1] raise: Error.
	self assert: q = (aCart quantityOf: self bookLTA).
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:57'!
test05CannotAddBooksFromAnotherPublisherToCart

	"Adding an item which is not in the catalogue should raise a NotFound exception"
	
	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	self assert: (aCart quantityOf: self bookSerDeRiver) = 0.
	self deny: (aCatalogue includes: self bookSerDeRiver).
	self should: [ (Cart withCatalogue: aCatalogue) add: self bookSerDeRiver quantity: 1] raise: NotFound.
	self assert: (aCart quantityOf: self bookSerDeRiver) = 0.	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:57'!
test06CannotCheckoutWithAnInvalidNumberedCreditCard

	|catalogue cart aNonNumericCard aWrongSizeCard invocationsBefore aMP|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS;yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 1; yourself.

	aNonNumericCard := CreditCard ownedBy: 'Somebody' identifiedBy: 'aaaabbbbccccdddd' expiresOn: MonthOfYear current.
	aWrongSizeCard := CreditCard ownedBy: 'Somebody' identifiedBy: '11112222333344445' expiresOn: MonthOfYear current.

	aMP := self merchantProcessorInterfaceREST.
	
	invocationsBefore := aMP numberOfInvocations.

	self should: [ Cashier new checkout: cart withCreditCard: aNonNumericCard using: aMP] raise: Error
			withExceptionDo: [:anError | 
				self assert: anError messageText = Cashier errorMessageInvalidCardNumber.
				aMP numberOfInvocations = invocationsBefore ].
	
	invocationsBefore := aMP numberOfInvocations.
	self should: [ Cashier new checkout: cart withCreditCard: aWrongSizeCard using: aMP] raise: Error
			withExceptionDo: [:anError | 
				self assert: anError messageText = Cashier errorMessageInvalidCardNumber.
				aMP numberOfInvocations = invocationsBefore ].
	
	
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:59'!
test07TotalPriceShouldBeGreaterThanZeroOnCheckout

	|aCatalogue aCart aValidCreditCard invocationsBefore aMerchantProcessorInterface|
	aCatalogue := Dictionary new at: self bookLTA put: self zeroARS; yourself.
	aCart := (Cart withCatalogue: aCatalogue) add: self bookLTA  quantity: 100; yourself.
	aValidCreditCard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.
	invocationsBefore := aMerchantProcessorInterface numberOfInvocations.
	
	self should: [Cashier new checkout: aCart withCreditCard: aValidCreditCard using: aMerchantProcessorInterface] raise: Error  withExceptionDo: [:anError | 
		self assert: anError messageText = Cashier errorMessageInvalidPrice.
		invocationsBefore = aMerchantProcessorInterface numberOfInvocations].
	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:59'!
test08CannotCheckoutIfCardHasExpired

	"Adding an item which is not in the catalogue should raise a NotFound exception"

	|catalogue cart ccard aMerchantProcessorInterface invocationsBefore|
	catalogue:=Dictionary new at: self book100MasDeUnSigloRojoYBlanco put: self oneHundredARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self book100MasDeUnSigloRojoYBlanco quantity: 3; yourself.
	ccard := CreditCard ownedBy: 'Somebody'  identifiedBy:  '1111222233334444' expiresOn: (MonthOfYear januaryOf: 1990).
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.
	invocationsBefore := aMerchantProcessorInterface numberOfInvocations.

	"En este caso como una tarjeta vencida se lo podria hasta considerar como parte normal del flujo de eventos modelados por el sistema, reificamos el error pues consideramos que es necesario identificarlo y hacer algo al respecto (por ejemplo, pedirle al cliente que provea otra tarjeta de credito)"
	self should: [ Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] raise: ExpiredCreditCardError withExceptionDo: [:anError | aMerchantProcessorInterface numberOfInvocations = invocationsBefore] .



! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:59'!
test09CannotCheckoutAnEmptyCart

	|catalogue cart ccard aMerchantProcessorInterface invocationsBefore|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := Cart withCatalogue: catalogue.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.
	invocationsBefore := aMerchantProcessorInterface numberOfInvocations.
	
	
	self should: [ Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] raise: Error
		withExceptionDo: [:anError | 
			anError messageText = Cashier errorMessageEmptyCard.
			invocationsBefore = aMerchantProcessorInterface numberOfInvocations.]


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:58'!
test10CheckoutKeepsCartInmutability

	|catalogue cart ccard itemsInCart catalogueInCart aMerchantProcessorInterface|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 5.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.

	itemsInCart := cart purchasedItems .
	catalogueInCart := cart purchaseCatalogue .

	[Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] on: Error do: [nil].
	
	self assert: (catalogueInCart  = cart purchaseCatalogue).
	self assert: (itemsInCart = cart purchasedItems).
	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:57'!
test11CheckoutKeepsCreditCardInmutability

	|catalogue cart ccard itemsInCart catalogueInCart aMerchantProcessorInterface|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 5.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.

	[Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] on: Error do: [nil].
	
	self assert: (ccard ownerName = 'Somebody').
	self assert: (ccard number = '1111222233334444').
	self assert: (ccard expirationDate = MonthOfYear current ).
	
	

	
		

! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/17/2012 22:14'!
zeroARS

	^MonetaryAmount of: 0 in: MonetaryCurrency ARS.
! !

Error subclass: #TusLibrosError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

TusLibrosError subclass: #ExpiredCreditCardError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'catalogue items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/13/2012 21:41'!
withCatalogue: aSet 
	
	
	 ^self new initializeWithCatalogue: aSet 
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 21:05'!
add: anItem quantity: aNumber


	(catalogue includesKey: anItem) ifFalse: [^NotFound signal: 'No existe el articulo en el catalogo'].
	(aNumber >= 0) ifFalse: [^Error signal: 'Se deben agregar cantidades mayores a cero'].
	
	items add: anItem withOccurrences: aNumber.
	
	

	


	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/13/2012 21:48'!
initializeWithCatalogue: aSet


		catalogue:=aSet.
		items:=Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 09:20'!
isEmpty

	^items isEmpty .
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 20:53'!
purchaseCatalogue

	^catalogue copy.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 20:53'!
purchasedItems

	^items copy.
	


! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 09:31'!
quantityOf: anItem 

	^items occurrencesOf: anItem.
	
! !

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 21:55'!
errorMessageEmptyCard 

	^'The cart is empty'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 21:56'!
errorMessageInvalidCardNumber 

	^'Invalid card number'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 22:11'!
errorMessageInvalidPrice

	^'Negative price'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:52'!
calculatePriceOf: purchasedItems over: aPurchaseCatalogue

	| totalValue |
	
	totalValue := purchasedItems inject: 0 into: [:accum :anItem | 
		| catalogueItem itemUnitPrice | 
		catalogueItem := aPurchaseCatalogue at: anItem.
		itemUnitPrice := catalogueItem amount * catalogueItem currency exchangeRateValue.
		accum + itemUnitPrice].

	^MonetaryAmount of: totalValue in: MonetaryCurrency ARS.
	
	
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:56'!
checkout: aCart withCreditCard: aCreditCard using: aMerchantProcessorInterface 

	| totalPrice |

	self validateCreditCard: aCreditCard.

	totalPrice := self calculatePriceOf: aCart purchasedItems over: aCart purchaseCatalogue.
	self validateTotalPrice: totalPrice.
	
	aMerchantProcessorInterface debitFrom: aCreditCard  theAmountOf:  totalPrice .

	


	
	
	
	
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 22:13'!
validateCreditCard: aCreditCard

	(aCreditCard isExpiredOn: MonthOfYear current) ifTrue:[^ExpiredCreditCardError signal: 'Tarjeta vencida'].
	(aCreditCard number matchesRegex: '[0-9]+') ifFalse: [^Error signal: Cashier errorMessageInvalidCardNumber].
	(aCreditCard number size = 16) ifFalse: [^Error signal: Cashier errorMessageInvalidCardNumber].
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 23:38'!
validateTotalPrice: aMonetaryAmount 

	(aMonetaryAmount amount > 0) ifFalse: [^Error signal: Cashier errorMessageInvalidPrice].


	
	
	
	
	! !

Object subclass: #MerchantProcessorInterface
	instanceVariableNames: 'numberOfInvocations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:06'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount 

	^self subclassResponsibility .! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:22'!
logDebit

	numberOfInvocations := numberOfInvocations  + 1.
! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:39'!
numberOfInvocations 

	^numberOfInvocations .! !

MerchantProcessorInterface subclass: #MerchantProcessorInterfaceREST
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterfaceREST methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:37'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount 

	self logDebit.
	^self shouldBeImplemented .! !

MerchantProcessorInterface subclass: #MerchantProcessorInterfaceStub
	instanceVariableNames: 'onDebitRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:10'!
respondingOnDebit: aDebitResponse

	^self new initializeWithDebitResponse: aDebitResponse ! !

!MerchantProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:38'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount 

	self logDebit.
	^onDebitRequest value.
! !

!MerchantProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:11'!
initializeWithDebitResponse: aDebitResponse


	onDebitRequest := aDebitResponse.! !

Object subclass: #MonetaryAmount
	instanceVariableNames: 'currencyValue amountValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MonetaryAmount class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:10'!
of: anAmount in: aCurrency


^self new initializeWithAmount: anAmount in: aCurrency.
! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
amount 

	^amountValue
	! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
currency

	^currencyValue ! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
initializeWithAmount: anAmount  in: aCurrency


	amountValue := anAmount.
	currencyValue := aCurrency.
	! !

Object subclass: #MonetaryCurrency
	instanceVariableNames: 'name rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:45'!
ARS

	^self named: 'ARS' withRate: 1.
	! !

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:41'!
named: aName withRate: anExchangeRate

	^self new initializeWithName: aName rate: anExchangeRate.! !

!MonetaryCurrency methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:33'!
exchangeRateValue

^rate.
! !

!MonetaryCurrency methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:27'!
initializeWithName: aName rate: anExchangeRate


	name := aName.
	rate := anExchangeRate.! !
